﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace DataGridTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ViewModel vm;
        private List<string> headers = new List<string>();

        public MainWindow(ViewModel vm)
        {
            InitializeComponent();
            this.vm = vm;
            this.DataContext = this.vm;
            //this.dataList.ItemsSource = this.vm.TestData;

            Model data1 = new Model();
            Model data2 = new Model();
            Model data3 = new Model();
            Model data4 = new Model();
            Model data5 = new Model();  
            
            Other a = new Other();
            Other b = new Other();
            Other c = new Other();
            Other d = new Other();

            
                  

            
            data1.Header = "Current";
            data1.Data.Add(17.254);
            data1.Data.Add(257.275454);
            data1.Data.Add(11.64084);
            data1.Data.Add(17.254);
            data1.Data.Add(257.275454);
            data1.Data.Add(11.64084);
           

            data2.Header = "Voltage";
            data2.Data.Add(17.254);
            data2.Data.Add(227.254996);
            data2.Data.Add(11.64084);
            data2.Data.Add(17.254);
            data2.Data.Add(227.254996);
            data2.Data.Add(11.64084);
            

            data3.Header = "Resistance";
            data3.Data.Add(17.254);
            data3.Data.Add(127.25401);
            data3.Data.Add(181.6004084);
            data3.Data.Add(17.254);
            data3.Data.Add(127.25401);
            data3.Data.Add(181.6004084);
            

            data4.Header = "Power";
            data4.Data.Add(197.254);
            data4.Data.Add(27.254);
            data4.Data.Add(141.644);
            data4.Data.Add(197.254);
            data4.Data.Add(27.254);
            data4.Data.Add(141.644);

            data5.Header = "Program Voltage";
            data5.Data.Add(197.25774);
            data5.Data.Add(27.254);
            data5.Data.Add(141.644);
            data5.Data.Add(197.254);
            data5.Data.Add(27.254);
            data5.Data.Add(141.644);
            

            vm.TestData.Add(data1);
            vm.TestData.Add(data2);
            vm.TestData.Add(data3);
            vm.TestData.Add(data4);
            vm.TestData.Add(data5);

            //UpdateGrid();
        }

        public void UpdateGrid()
        {

            /*
            foreach (Other data in vm.OtherData)
            {
                if (headers.Contains(data.Name) == false)
                {
                    headers.Add(data.Name);
                    DataGridTextColumn col = new DataGridTextColumn();
                    int x = vm.OtherData.IndexOf(data);
                    Binding bind = new Binding("Data");                                                     
                    //bind.BindsDirectlyToSource = true;
                    col.Binding = bind;
                    col.Header = data.Name;                    
                    this.spreadsheet.Columns.Add(col);
                    ListView list = new ListView();
                }

            }
             

            foreach (Model data in vm.TestData)
            {
                if (headers.Contains(data.Header) == false)
                {
                    headers.Add(data.Header);
                    GridViewColumn col = new GridViewColumn();
                    int index = vm.TestData.IndexOf(data);
                    col.Header = data.Header;
                    Binding bind = new Binding("Data[" + index + "]");
                    //bind.Source = vm.TestData[index];
                    col.DisplayMemberBinding = bind;
                    this.dataView.Columns.Add(col);
                }
            }
             * * */
        }

        private void spreadsheet_CellEditEnding(object sender, DataGridCellEditEndingEventArgs e)
        {
            int x = 1;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            ObservableCollection<Model> mods = new ObservableCollection<Model>();

            Model data1 = new Model();
            Model data2 = new Model();
            Model data3 = new Model();
            Model data4 = new Model();
            Model data5 = new Model();

            data1.Header = "Current";
            data1.Data.Add(17.254);
            data1.Data.Add(257.275454);
            data1.Data.Add(11.64084);
            data1.Data.Add(17.254);
            data1.Data.Add(257.275454);
            data1.Data.Add(11.64084);


            data2.Header = "Voltage";
            data2.Data.Add(17.254);
            data2.Data.Add(227.254996);
            data2.Data.Add(11.64084);
            data2.Data.Add(17.254);
            data2.Data.Add(227.254996);
            data2.Data.Add(11.64084);


            data3.Header = "Resistance";
            data3.Data.Add(17.254);
            data3.Data.Add(127.25401);
            data3.Data.Add(181.6004084);
            data3.Data.Add(17.254);
            data3.Data.Add(127.25401);
            data3.Data.Add(181.6004084);


            data4.Header = "Power";
            data4.Data.Add(197.254);
            data4.Data.Add(27.254);
            data4.Data.Add(141.644);
            data4.Data.Add(197.254);
            data4.Data.Add(27.254);
            data4.Data.Add(141.644);

            data5.Header = "Program Voltage";
            data5.Data.Add(197.25774);
            data5.Data.Add(27.254);
            data5.Data.Add(141.644);
            data5.Data.Add(197.254);
            data5.Data.Add(27.254);
            data5.Data.Add(141.644);

            mods.Add(data1);
            mods.Add(data2);
            mods.Add(data3);
            mods.Add(data4);
            mods.Add(data5);

            anotherUpdate(mods);

        } 

        private void anotherUpdate(ObservableCollection<Model> modely)
        {
            foreach (Model newmod in modely)
            {
                foreach (Model mod in vm.TestData)
                {
                    if (newmod.Header == mod.Header)
                    {
                        int x = vm.TestData.IndexOf(mod);
                        IEnumerable<double> temp;
                        temp = vm.TestData[x].Data.Concat(mod.Data);
                        vm.TestData[x].Data = new ObservableCollection<double>(temp);
                        int yt = 7;
                    }
                }
            }
        }

        private void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            for (int i = 0; i < ((this.DataContext as ViewModel).TestData.FirstOrDefault() as Model).Data.Count; i++)
            {
                e.FieldLayout.Fields.Add(new UnboundField() { BindingPath = new PropertyPath("Data[" + i + "]", null) });
            }
        }
    }
}
